import HelloWorld.*;           // The package containing our stubs.
import org.omg.CosNaming.*;  // CORBAClient will use the naming service.
import org.omg.CORBA.*;      // All CORBA applications need these classes.


public class HelloClient
{
  public static void main(String args[])
  {
    try{
      
      // Create and initialize the ORB
      ORB orb = ORB.init(args, null);
      
      // Get the root naming context
      org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
      NamingContextExt ncRef = NamingContextExtHelper.narrow(objRef);
      
      // Resolve the object reference in naming
      NameComponent path[] = ncRef.to_name("HelloWorld");
      Hello helloRef = HelloHelper.narrow(ncRef.resolve(path));
     
   	  System.out.println(helloRef.sayHello("Peter"));

      NVList argList = orb.create_list(1);
      Any arg1 = orb.create_any();
      arg1.insert_string("Roland");
	  NamedValue nv = argList.add_value("name", arg1, ARG_IN.value);

      Any res = orb.create_any();
      res.insert_string("");
	  NamedValue resv = orb.create_named_value("result", res, ARG_OUT.value);

      Request req = helloRef._create_request(null, "sayHello", argList, resv);
	  //req.invoke();
	  req.send_deferred();
   	  System.out.println("Request is executing ...");
	  req.get_response();

   	  System.out.println(res.extract_string());

    } catch(Exception e) {
        System.out.println("ERROR : " + e);
        e.printStackTrace(System.out);
      }  
  }
}


